// ignore_for_file: unnecessary_brace_in_string_interps

import 'package:galaxeus_lib/extension/regexp.dart';

extension GalaxeusExtensionString on String {
  String hideData({int start = 2, int end = 2}) {
    var message = "";
    var numStart = start;
    var numEnd = length - end;
    for (int i = 0; i < length; i++) {
      var loopData = this[i];
      if (i == numEnd) {
        numEnd--;
        message += loopData;
      } else if (i == numStart) {
        numStart++;
        message += "*";
      } else {
        message += loopData;
      }
    }
    return message;
  }

  String camelCaseClass({RegExp? regExp}) {
    regExp ??= RegExp(r"(_)", caseSensitive: false);
    String text = "";
    for (var i = 0; i < length; i++) {
      var loopData = this[i];
      if (i == 0) {
        text += loopData.toUpperCase();
      } else {
        if (regExp.hasMatch(text[text.length - 1])) {
          text += loopData.toUpperCase();
        } else {
          text += loopData;
        }
      }
    }
    return text.replaceAll(regExp, "");
  }

  String snakeCaseClass({RegExp? regExp}) {
    regExp ??= RegExp(r"(_)", caseSensitive: false);
    String text = "";
    for (var i = 0; i < length; i++) {
      var loopData = this[i];
      if (RegExp(r"[A-Z]").hashData(loopData) && i != 0) {
        text += "_${loopData}";
      } else {
        text += loopData;
      }
    }
    return text.toLowerCase();
  }
}
